echo("in da script");

exec("scripts/Doors.cs");

$Vehiclemax[ScoutVehicle] = 4;
$Vehiclemax[AssaultVehicle] = 6;
$Vehiclemax[ScoutFlyer] = 2;
$Vehiclemax[BomberFlyer] = 6;
$Vehiclemax[HAPCFlyer] = 4;


activatePackage(Convoy);

game.gensDead = 0;
game.winByConvoy = 0;
game.winFirstByConvoy = 0;
game.winSecondByConvoy = 0;
game.objectiveReached = 0;
game.startDmg = 0;

game.adown = 0;
game.bdown = 0;
game.cdown = 0;
game.ddown = 0;

//check for a defensive win begginning at 1min in
schedule( 60000, 0, checkObjectiveReached );

package Convoy {

function checkObjectiveReached()
{
	if( game.objectiveReached == 0 )
	{
		checkObjectiveReachedByOne( nameToId("Alpha") );
		checkObjectiveReachedByOne( nameToId("Beta") );
		checkObjectiveReachedByOne( nameToId("Gamma") );
		checkObjectiveReachedByOne( nameToId("Delta") );

		//checks every 5 seconds
		schedule( 5000, 0, checkObjectiveReached );
	}
}

function checkObjectiveReachedByOne(%obj)
{
	%Xpos = getWord(%obj.Position, 0);
	%Ypos = getWord(%obj.Position, 1);
	if( %Xpos < 4526.92 && %Xpos > 4467.06 && %Ypos < 605.114 && %Ypos > 546.501)
	{
		defenseWins();
		game.objectiveReached = 1;
	}
	else if( %Ypos < -968 || %Ypos > 1560 || %Xpos < -864 || %Xpos > 5153 )
	{
	        	messageAll('MsgMPBOOB', '\c2An MPB has strayed Out-of-bounds and has begun taking damage!');
		%dmg = %obj.getDamageLevel();
		%dmg++;
		if( %dmg > 6 )
		{
			%dmg = 6;
		}
		%obj.setDamageLevel( %dmg );
	}
}

function defenseWins()
{
   game.winByConvoy = 1;
   %defTeam = Game.offenseTeam == 1 ? 2 : 1;
   %offTeam = Game.offenseTeam == 1 ? 1 : 2;

   // Let the observers know:
   messageTeam( 0, 'GotToNeothgard', 'The Convoy reached Neothgard!~wfx/misc/flipflop_taken.wav');
   // Let the teammates know:
   messageTeam( %defTeam, 'GotToNeothgard', 'The Convoy reached Neothgard!~wfx/misc/flipflop_taken.wav');
   // Let the other team know:
   messageTeam( %offTeam, 'GotToNeothgard', 'The Convoy reached Neothgard!~wfx/misc/flipflop_lost.wav');

   Game.allObjectivesCompleted();
}

//overwrites the default siege game allobjectivescompleted function
function SiegeGame::allObjectivesCompleted(%game)
{
   Cancel( %game.timeSync );
   Cancel( %game.timeThread );
   cancelEndCountdown();

    if( game.winByConvoy == 1 )
   {
   	game.winFirstByConvoy = Game.offenseTeam == 1 ? game.winFirstByConvoy : 1;
   	game.winSecondByConvoy = Game.offenseTeam == 1 ? 1 : game.winSecondByConvoy;
   }

   %defenseTeam = %game.offenseTeam == 1 ? 2 : 1;

   //store the elapsed time in the teamScore array...
   if( game.winByConvoy == 1 )
   {
        $teamScore[%defenseTeam] = getSimTime() - %game.startTimeMS;
        messageAll('MsgSiegeArrived', '\c2Team %1 arrived at the base in %2!', $teamName[%defenseTeam], %game.formatTime($teamScore[%defenseTeam], true));

        game.winByConvoy = 0;

      //set the new timelimit
      %game.timeLimitMS = $teamScore[%defenseTeam];
   }
   else
   {
        $teamScore[%game.offenseTeam] = getSimTime() - %game.startTimeMS;
        messageAll('MsgSiegeCaptured', '\c2Team %1 captured the base in %2!', $teamName[%game.offenseTeam], %game.formatTime($teamScore[%game.offenseTeam], true));

      //set the new timelimit
      %game.timeLimitMS = $teamScore[%game.offenseTeam];
   }

echo("defense team: " @ %defenseTeam );
echo("offense team: " @ %game.offenseTeam );
echo("defense team score: " @ $teamScore[%defenseTeam] );
echo("offense team score: " @ $teamScore[%game.offenseTeam] );

   if (%game.firstHalf)
   {
      // it's halftime, let everyone know
      messageAll( 'MsgSiegeHalftime' );
   }
   else
   {
      // game is over
      messageAll('MsgSiegeMisDone', '\c2Mission complete.');
   }
   logEcho("objective completed in "@%game.timeLimitMS);

   //setup the second half...
   // MES -- per MarkF, scheduling for 0 seconds will prevent player deletion-related crashes
   %game.schedule(0, halftime, 'objectives');
}


function SiegeGame::halftime(%game, %reason)
{
   //stop the game and the bots
   $MatchStarted = false;
   AISystemEnabled(false);

   if (%game.firstHalf)
   {
echo("b4 reset");
      resetStuff();
echo("after reset");
      //switch the game variables
      %game.firstHalf = false;
      %oldOffenseTeam = %game.offenseTeam;
      if (%game.offenseTeam == 1)
         %game.offenseTeam = 2;
      else
         %game.offenseTeam = 1;

      //send the message
      messageAll('MsgSiegeRolesSwitched', '\c2Team %1 is now on offense.', $teamName[%game.offenseTeam], %game.offenseTeam);

      //reset stations and vehicles that players were using
      %game.resetPlayers();
      // zero out the counts for deployable items (found in defaultGame.cs)
      %game.clearDeployableMaxes();

      // clean up the MissionCleanup group - note, this includes deleting all the player objects
      %clean = nameToID("MissionCleanup");
      %clean.housekeeping();

      // Non static objects placed in original position
      resetNonStaticObjPositions();
      
      // switch the teams for objects belonging to the teams
      %group = nameToID("MissionGroup/Teams");
      %group.swapTeams();
      // search for vehicle pads also
      %mcg = nameToID("MissionCleanup");
      %mcg.swapVehiclePads();

      //restore the objects
      %game.restoreObjects();

      %count = ClientGroup.getCount();
      for(%cl = 0; %cl < %count; %cl++)
      {
         %client = ClientGroup.getObject(%cl);
         if( !%client.isAIControlled() )
         {
            // Put everybody in observer mode:
            %client.camera.getDataBlock().setMode( %client.camera, "observerStaticNoNext" );
            %client.setControlObject( %client.camera );

	// Send the halftime result info:
            	if ( %client.team == %oldOffenseTeam )
            	{
        	       	if ( $teamScore[%oldOffenseTeam] > 0 )
                  	{
			messageClient( %client, 'MsgSiegeResult', "", '%1 captured the %2 base in %3!', %game.capPlayer[%oldOffenseTeam], $teamName[%game.offenseTeam], %game.formatTime( $teamScore[%oldOffenseTeam], true ) );
		}
               		else if ( $teamScore[%offenseTeam] > 0 )
		{
			messageClient( %client, 'MsgSiegeResult', "", '%1 brought their convoy to Neothgard in %2!', $teamName[%game.offenseTeam], %game.formatTime( $teamScore[%offenseTeam], true ) );
		}
		else
                  	{
			messageClient( %client, 'MsgSiegeResult', "", 'Your team failed to capture the %1 base.', $teamName[%game.offenseTeam] );   
            		}
	}
            	else
	{
	 	if ( $teamScore[%oldOffenseTeam] > 0 )
                 		{
			messageClient( %client, 'MsgSiegeResult', "", '%1 captured your base in %2!', %game.capPlayer[%oldOffenseTeam], %game.formatTime( $teamScore[%oldOffenseTeam], true ) );
            		}
		else if ( $teamScore[%offenseTeam] > 0 )
		{
		 	messageClient( %client, 'MsgSiegeResult', "", 'Your team brought the convoy to Neothgard in %1!', %game.formatTime( $teamScore[%oldOffenseTeam], true ) );

		}
		else
               		{
			messageClient( %client, 'MsgSiegeResult', "", 'Your team successfully held off team %1!', $teamName[%oldOffenseTeam] );   
		}            
	}

            // List out the team rosters:
            messageClient( %client, 'MsgSiegeAddLine', "", '<spush><color:00dc00><font:univers condensed:18><clip%%:50>%1</clip><lmargin%%:50><clip%%:50>%2</clip><spop>', $TeamName[1], $TeamName[2] );
            %max = $TeamRank[1, count] > $TeamRank[2, count] ? $TeamRank[1, count] : $TeamRank[2, count];
            for ( %line = 0; %line < %max; %line++ )
            {
               %plyr1 = $TeamRank[1, %line] $= "" ? "" : $TeamRank[1, %line].name;
               %plyr2 = $TeamRank[2, %line] $= "" ? "" : $TeamRank[2, %line].name;
               messageClient( %client, 'MsgSiegeAddLine', "", '<lmargin:0><clip%%:50> %1</clip><lmargin%%:50><clip%%:50> %2</clip>', %plyr1, %plyr2 );
            }

            // Show observers:
            %header = false;
            for ( %i = 0; %i < %count; %i++ )
            {
               %obs = ClientGroup.getObject( %i );
               if ( %obs.team <= 0 )
               {
                  if ( !%header )
                  {
                     messageClient( %client, 'MsgSiegeAddLine', "", '\n<lmargin:0><spush><color:00dc00><font:univers condensed:18>OBSERVERS<spop>' );
                     %header = true;
                  }

                  messageClient( %client, 'MsgSiegeAddLine', "", ' %1', %obs.name );
               }
            }
            
            commandToClient( %client, 'SetHalftimeClock', $Host::Siege::Halftime / 60000 );
            
            // Get the HUDs right:
            commandToClient( %client, 'setHudMode', 'SiegeHalftime' );
            commandToClient( %client, 'ControlObjectReset' );
            
            clientResetTargets(%client, true);
            %client.notReady = true;
         }
      }
      
      %game.schedule( $Host::Siege::Halftime, halftimeOver );
   }
   else
   {
      // let's wrap it all up
      %game.gameOver();
      cycleMissions();
   }
//echo("At end of Halftime report");
//echo("defense team: " @ %oldOffenseTeam );
//echo("offense team: " @ %game.offenseTeam );
//echo("defense team score: " @ $teamScore[%oldOffenseTeam] );
//echo("offense team score: " @ $teamScore[%game.offenseTeam] );

}



function SiegeGame::sendDebriefing( %game, %client )
{
   //if neither team captured
   %winnerName = "";
   if ( $teamScore[1] == 0 && $teamScore[2] == 0 )
      %winner = -1;

   //else see if team1 won
   else if ( $teamScore[1] > 0 && ( $teamScore[2] == 0 || $teamScore[1] < $teamScore[2] ) )
   {
      %winner = 1;
      %winnerName = $teamName[1];
   }

   //else see if team2 won
   else if ($teamScore[2] > 0 && ($teamScore[1] == 0 || $teamScore[2] < $teamScore[1]))
   {
      %winner = 2;
      %winnerName = $teamName[2];
   }

   //else see if it was a tie (right down to the millisecond - doubtful)
   else if ($teamScore[1] == $teamScore[2])
      %winner = 0;

   //send the winner message
   if (%winnerName $= 'Storm')
      messageClient( %client, 'MsgGameOver', "Match has ended.~wvoice/announcer/ann.stowins.wav" );
   else if (%winnerName $= 'Inferno')
      messageClient( %client, 'MsgGameOver', "Match has ended.~wvoice/announcer/ann.infwins.wav" );
   else
      messageClient( %client, 'MsgGameOver', "Match has ended.~wvoice/announcer/ann.gameover.wav" );

   // Mission result:
   if (%winner > 0)
   {
      if (%winner == 1)
      {  
         if ($teamScore[2] == 0)
            messageClient(%client, 'MsgDebriefResult', "", '<just:center>Team %1 wins!', $TeamName[1]);
         else if( game.winByConvoy == 1 )
         {
            %timeDiffMS = $teamScore[2] - $teamScore[1];
            messageClient(%client, 'MsgDebriefResult', "", '<just:center>Team %1 won by arriving at Neothgard %2 faster!', $TeamName[1], %game.formatTime(%timeDiffMS, true));
         }
         else
         {
            %timeDiffMS = $teamScore[2] - $teamScore[1];
            messageClient(%client, 'MsgDebriefResult', "", '<just:center>Team %1 won by capturing the base %2 faster!', $TeamName[1], %game.formatTime(%timeDiffMS, true));
         }
      }
      else
      {
         if ($teamScore[1] == 0)
            messageClient(%client, 'MsgDebriefResult', "", '<just:center>Team %1 wins!', $TeamName[2]);
         else if( game.winByConvoy == 1 )
         {
            %timeDiffMS = $teamScore[1] - $teamScore[2];
            messageClient(%client, 'MsgDebriefResult', "", '<just:center>Team %1 won by arriving at Neothgard %2 faster!', $TeamName[2], %game.formatTime(%timeDiffMS, true));
         }
         else
         {
            %timeDiffMS = $teamScore[1] - $teamScore[2];
            messageClient(%client, 'MsgDebriefResult', "", '<just:center>Team %1 won by capturing the base %2 faster!', $TeamName[2], %game.formatTime(%timeDiffMS, true));
         }
      }
   }
   else
      messageClient( %client, 'MsgDebriefResult', "", '<just:center>The mission ended in a tie.' );

   // Game summary:
   messageClient( %client, 'MsgDebriefAddLine', "", '<spush><color:00dc00><font:univers condensed:18>SUMMARY:<spop>' );
   %team1 = %game.offenseTeam == 1 ? 2 : 1;
   %team2 = %game.offenseTeam;
   if ( $teamScore[%team1] > 0 )
   {  
      %timeStr = %game.formatTime($teamScore[%team1], true);
      if( game.winFirstByConvoy == 1 )
	messageClient( %client, 'MsgDebriefAddLine', "", '<bitmap:bullet_2><lmargin:24>The %1 convoy arrived at Neothgard in %2.<lmargin:0>', $TeamName[%team1], %timeStr);
      else	
      messageClient( %client, 'MsgDebriefAddLine', "", '<bitmap:bullet_2><lmargin:24>%1 captured the %2 base for Team %3 in %4.<lmargin:0>', %game.capPlayer[%team1], $TeamName[%team2], $TeamName[%team1], %timeStr);
   }
   else
      messageClient( %client, 'MsgDebriefAddLine', "", '<bitmap:bullet_2><lmargin:24>Team %1 failed to capture the base.<lmargin:0>', $TeamName[%team1]);

   if ( $teamScore[%team2] > 0 )
   {  
      %timeStr = %game.formatTime($teamScore[%team2], true);
      if( game.winSecondByConvoy == 1 )
	messageClient( %client, 'MsgDebriefAddLine', "", '<bitmap:bullet_2><lmargin:24>The %1 convoy arrived at Neothgard in %2.<lmargin:0>', $TeamName[%team2], %timeStr);
      else	
      messageClient( %client, 'MsgDebriefAddLine', "", '<bitmap:bullet_2><lmargin:24>%1 captured the %2 base for Team %3 in %4.<lmargin:0>', %game.capPlayer[%team2], $TeamName[%team1], $TeamName[%team2], %timeStr);
   }
   else
      messageClient( %client, 'MsgDebriefAddLine', "", '<bitmap:bullet_2><lmargin:24>Team %1 failed to capture the base.<lmargin:0>', $TeamName[%team2]);

   // List out the team rosters:
   messageClient( %client, 'MsgDebriefAddLine', "", '\n<spush><color:00dc00><font:univers condensed:18><clip%%:50>%1</clip><lmargin%%:50><clip%%:50>%2</clip><spop>', $TeamName[1], $TeamName[2] );
   %max = $TeamRank[1, count] > $TeamRank[2, count] ? $TeamRank[1, count] : $TeamRank[2, count];
   for ( %line = 0; %line < %max; %line++ )
   {
      %plyr1 = $TeamRank[1, %line] $= "" ? "" : $TeamRank[1, %line].name;
      %plyr2 = $TeamRank[2, %line] $= "" ? "" : $TeamRank[2, %line].name;
      messageClient( %client, 'MsgDebriefAddLine', "", '<lmargin:0><clip%%:50> %1</clip><lmargin%%:50><clip%%:50> %2</clip>', %plyr1, %plyr2 );
   }

   // Show observers:
   %count = ClientGroup.getCount();
   %header = false;
   for ( %i = 0; %i < %count; %i++ )
   {
      %cl = ClientGroup.getObject( %i );
      if ( %cl.team <= 0 )
      {
         if ( !%header )
         {
            messageClient( %client, 'MsgDebriefAddLine', "", '\n<lmargin:0><spush><color:00dc00><font:univers condensed:18>OBSERVERS<spop>' );
            %header = true;
         }

         messageClient( %client, 'MsgDebriefAddLine', "", ' %1', %cl.name );
      }
   }
}




function SiegeGame::updateScoreHud(%game, %client, %tag)
{
   %timeElapsedMS = getSimTime() - %game.startTimeMS;
   %curTimeLeftMS = %game.timeLimitMS - %timeElapsedMS;
   %game.defenseTeam = %game.offenseTeam == 1 ? 2 : 1;

   if (!$MatchStarted)
      %curTimeLeftStr = %game.formatTime(%game.timelimitMS, false);
   else
      %curTimeLeftStr = %game.formatTime(%curTimeLeftMS, false);

   // Send header:
   if (%game.firstHalf)
      messageClient( %client, 'SetScoreHudHeader', "", '<just:center>Team %1 has %2 to capture the base.', 
            $teamName[%game.offenseTeam], %curTimeLeftStr ); 
   else
     if( game.winByConvoy == 1 )
        messageClient( %client, 'SetScoreHudHeader', "", '<just:center>Team %1 must reach Neothgard within %2 to win.', 
            $teamName[%game.defenseTeam], %curTimeLeftStr );
     else 
        messageClient( %client, 'SetScoreHudHeader', "", '<just:center>Team %1 must capture the base within %2 to win.', 
            $teamName[%game.offenseTeam], %curTimeLeftStr );

   // Send subheader:
   messageClient( %client, 'SetScoreHudSubheader', "", '<tab:15,315>\t%1 (%2)\t%3 (%4)',
         $TeamName[1], $TeamRank[1, count], $TeamName[2], $TeamRank[2, count] );

   %index = 0;
   while (true)
   {
      if (%index >= $TeamRank[1, count] && %index >= $TeamRank[2, count])
         break;

      //get the team1 client info
      %team1Client = "";
      %team1ClientScore = "";
      %col1Style = "";
      if (%index < $TeamRank[1, count])
      {
         %team1Client = $TeamRank[1, %index];
         %team1ClientScore = %team1Client.score $= "" ? 0 : %team1Client.score;
         if ( %team1Client == %client )
            %col1Style = "<color:dcdcdc>";
      }

      //get the team2 client info
      %team2Client = "";
      %team2ClientScore = "";
      %col2Style = "";
      if (%index < $TeamRank[2, count])
      {
         %team2Client = $TeamRank[2, %index];
         %team2ClientScore = %team2Client.score $= "" ? 0 : %team2Client.score;
         if ( %team2Client == %client )
            %col2Style = "<color:dcdcdc>";
      }


      //if the client is not an observer, send the message
      if (%client.team != 0)
      {
         messageClient( %client, 'SetLineHud', "", %tag, %index, '<tab:20,320>\t<spush>%3<clip:200>%1</clip><spop>\t%4<clip:200>%2</clip>', 
               %team1Client.name, %team2Client.name, %col1Style, %col2Style );
      }
      //else for observers, create an anchor around the player name so they can be observed
      else
      {
         messageClient( %client, 'SetLineHud', "", %tag, %index, '<tab:20,320>\t<spush>%3<clip:200><a:gamelink\t%5>%1</a></clip><spop>\t%4<clip:200><a:gamelink\t%6>%2</a></clip>', 
               %team1Client.name, %team2Client.name, %col1Style, %col2Style, %team1Client, %team2Client );
      }

      %index++;
   }

   // Tack on the list of observers:
   %observerCount = 0;
   for (%i = 0; %i < ClientGroup.getCount(); %i++)
   {
      %cl = ClientGroup.getObject(%i);
      if (%cl.team == 0)
         %observerCount++;
   }

   if (%observerCount > 0)
   {
	   messageClient( %client, 'SetLineHud', "", %tag, %index, "");
      %index++;
		messageClient(%client, 'SetLineHud', "", %tag, %index, '<tab:10, 310><spush><font:Univers Condensed:22>\tOBSERVERS (%1)<rmargin:260><just:right>TIME<spop>', %observerCount);
      %index++;
      for (%i = 0; %i < ClientGroup.getCount(); %i++)
      {
         %cl = ClientGroup.getObject(%i);
         //if this is an observer
         if (%cl.team == 0)
         {
            %obsTime = getSimTime() - %cl.observerStartTime;
            %obsTimeStr = %game.formatTime(%obsTime, false);
		      messageClient( %client, 'SetLineHud', "", %tag, %index, '<tab:20, 310>\t<clip:150>%1</clip><rmargin:260><just:right>%2',
		                     %cl.name, %obsTimeStr );
            %index++;
         }
      }
   }

   //clear the rest of Hud so we don't get old lines hanging around...
   messageClient( %client, 'ClearHud', "", %tag, %index );
}



//checks if all gens are dead, if so, speacial fx on switch
function AnotherDead()
{
	echo("in anotherDead");
	game.gensDead = game.gensDead + 1;
	if( game.gensDead == 4 ) 
	{
		%fX = "372";
		%fY = "585";
		%fZ = "138";
		randomDet( %fX, %fY, %fZ );
	}
}

function randomDet(%posX,%posY,%posZ)
{
	echo("in randomDet");
	%numDet = 2;
	for( %i = 0; %i < %numDet; %i = %i + 1 )
	{ 
		%rposx = getRandom( 3 * 2 ) - 3;
		%rposy = getRandom( 3 * 2 ) - 3;
		%rposz = getRandom( 3 * 2 ) - 3;
		%tposX = %posX + %rposx;
		%tposY = %posY + %rposy;
		%tposZ = %posZ + %rposz;
		schedule( %i * 2500, 0, detSatchel, %tposX, %tposY, %tposZ );
	}
}

//creates and explodes one satchel at specified location
function detSatchel(%posX,%posY,%posZ)
{
	echo("in detSatchel");
	%Charge = new Item() {	
		position = %posX @ " " @ %posY @ " " @ %posZ;
		dataBlock = "SatchelChargeThrown";
			locked = "true";
			armed = "true";
			damaged = "0";
	};
  	//MissionCleanup.add(%Charge);

	//%Charge = nameToId( "ACharge" );
	//%Charge.setTransform(%Charge.getTransform());
                  %Charge.setDamageLevel(0.6);
	//playAudio(800, SatchelChargeExplosionSound); 
                  //schedule(800, 0, "detonateSatchelCharge", %ACharge);
         %dmgRadius = 10;
         %dmgMod = 0.3;
         %expImpulse = 1000;
         %dmgType = $DamageType::Explosion;
      RadiusExplosion(%Charge, %Charge.getPosition(), %dmgRadius, %dmgMod, %expImpulse, %Charge.sourceObject, %dmgType);

	//armSatchelCharge( %Charge );
	//%Charge.setDamageState(Destroyed);
      	//%Charge.blowup(); 

	%Charge.schedule(2000, "delete");
}

//kills gens on mpb destruction
function VehicleData::onDestroyed(%data, %obj, %prevState)
{
	echo("in onDestroyed");
	Parent::onDestroyed(%data,%obj,%prevState);

	if(%obj == nameToId("Alpha") )
	{
	  	MessageAll('MsgAlphaDown', "\c2Alpha Generator Destroyed!");

		OpenDoor(NameToID("TowerA"), 5000, 0, 0, 0, -30 );
		game.adown = 1;

		%fX = "373";
		%fY = "627";
		%fZ = "131";
		randomDet( %fX, %fY, %fZ );
		nameToId("Tower1Gen").setDamageLevel(2.5);
		AnotherDead();
	}
	else if(%obj == nameToId("Beta") )
	{
	  	MessageAll('MsgBetaDown', "\c2Beta Generator Destroyed!");

		OpenDoor(NameToID("TowerB"), 5000, 0, 0, 0, -30 );
		game.bdown = 1;

		%fX = "407";
		%fY = "585";
		%fZ = "131";
		randomDet( %fX, %fY, %fZ );
		nameToId("Tower2Gen").setDamageLevel(2.5);

		AnotherDead();
	}
	else if(%obj == nameToId("Gamma") )
	{
	  	MessageAll('MsgGammaDown', "\c2Gamma Generator Destroyed!");

		OpenDoor(NameToID("TowerC"), 5000, 0, 0, 0, -30 );
		game.cdown = 1;
		
		%fX = "376";
		%fY = "544";
		%fZ = "131";
		randomDet( %fX, %fY, %fZ );
		nameToId("Tower3Gen").setDamageLevel(2.5);

		AnotherDead();
	}
	else if(%obj == nameToId("Delta") )
	{
	  	MessageAll('MsgDeltaDown', "\c2Delta Generator Destroyed!");

		OpenDoor(NameToID("TowerD"), 5000, 0, 0, 0, -30 );
		game.ddown = 1;

		%fX = "337";
		%fY = "585";
		%fZ = "131";
		randomDet( %fX, %fY, %fZ );
		nameToId("Tower4Gen").setDamageLevel(2.5);

		AnotherDead();
	}
}



//reset at the half
function resetStuff()
{
	if( game.adown == 1 )
		OpenDoor(NameToID("TowerA"), 500, 0, 0, 0, 30 );
	if( game.bdown == 1 )
		OpenDoor(NameToID("TowerB"), 500, 0, 0, 0, 30 );
	if( game.cdown == 1 )
		OpenDoor(NameToID("TowerC"), 500, 0, 0, 0, 30 );
	if( game.ddown == 1 )
		OpenDoor(NameToID("TowerD"), 500, 0, 0, 0, 30 );
}

function SiegeGame::halftimeOver( %game )
{
	Parent::halfTimeOver(%game);
	//echo("in halftimeover");
	game.gensDown = 0;
	
	//delete all starting vehivles
	nameToID("Alpha").delete();
	nameToID("Beta").delete();
	nameToID("Gamma").delete();
	nameToID("Delta").delete();
	nameToID("Extra1").delete();
	nameToID("Extra2").delete();
	nameToID("Extra3").delete();
	nameToID("Extra4").delete();

	//reset all start vehicles

	%group = nameToID("MissionGroup/Teams/Team2/base");

				%temp = new WheeledVehicle(Alpha) {
					position = "453 555.505 131.206";
					rotation = "0.00962178 -0.00249749 0.999951 29.0949";
					scale = "1 1 1";
					dataBlock = "mobileBaseVehicle";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
						selfPower = "1";
						locked = "true";
						team = "2";
						mountable = "1";
						Target = "46";
						respawn = "0";
				};
	%group.add(%temp);
				%temp = new WheeledVehicle(Beta) {
					position = "448 522.111 131.21";
					rotation = "0.00974623 -0.00262915 0.999949 33.8035";
					scale = "1 1 1";
					dataBlock = "mobileBaseVehicle";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
						selfPower = "1";
						locked = "true";
						team = "2";
						mountable = "1";
						Target = "47";
						respawn = "0";
				};
	%group.add(%temp);
				%temp = new WheeledVehicle(Gamma) {
					position = "420 529.295 131.228";
					rotation = "0.00651722 -0.0099132 0.99993 37.0242";
					scale = "1 1 1";
					dataBlock = "mobileBaseVehicle";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
						selfPower = "1";
						locked = "true";
						team = "2";
						mountable = "1";
						Target = "48";
						respawn = "0";
				};
	%group.add(%temp);
				%temp = new WheeledVehicle(Delta) {
					position = "398 506.06 131.206";
					rotation = "0.00925353 -0.00250766 0.999954 30.3183";
					scale = "1 1 1";
					dataBlock = "mobileBaseVehicle";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
						selfPower = "1";
						locked = "true";
						team = "2";
						mountable = "1";
						Target = "49";
						respawn = "0";
				};
	%group.add(%temp);
				%temp = new FlyingVehicle() {
					position = "363 464.036 133.937";
					rotation = "0 0 1 45.2636";
					scale = "1 1 1";
					dataBlock = "ScoutFlyer";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
						selfPower = "1";
						locked = "true";
						team = "2";
						mountable = "1";
						nextWeaponFire = "2";
						Target = "56";
						respawn = "0";
				};
	%group.add(%temp);
				%temp = new HoverVehicle() {
					position = "457 573.453 131.031";
					rotation = "0 0 1 60.7331";
					scale = "1 1 1";
					dataBlock = "AssaultVehicle";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
						selfPower = "1";
						locked = "true";
						team = "2";
						mountable = "1";
						turretObject = "3372";
						Target = "51";
						respawn = "0";
				};
	%group.add(%temp);
				%temp = new HoverVehicle() {
					position = "377 493.875 131.031";
					rotation = "0 0 1 30.9397";
					scale = "1 1 1";
					dataBlock = "AssaultVehicle";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
						selfPower = "1";
						locked = "true";
						team = "2";
						mountable = "1";
						turretObject = "3374";
						Target = "53";
						respawn = "0";
				};
	%group.add(%temp);
				%temp = new FlyingVehicle() {
					position = "353 495.892 133.937";
					rotation = "0 0 1 48.1282";
					scale = "1 1 1";
					dataBlock = "ScoutFlyer";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
						selfPower = "1";
						locked = "true";
						team = "2";
						mountable = "1";
						nextWeaponFire = "2";
						Target = "55";
						respawn = "0";
				};
	%group.add(%temp);


	game.objectiveReached = 0;
	//check for a defensive win begginning at 1min in
	schedule( 60000, 0, checkObjectiveReached );

}

};//end of package Convoy

//echo("After package");


